<template>
  <div class="container mx-auto">
    <div class="entry__buttons-container p-6 mt-10 mb-6">
      <div class="entry__buttons rounded-lg" :overflow="totalLines > 1">
        <EntryButton
          v-for="(game, index) in games"
          :key="index"
          :is-active="activeBtn ? activeBtn.GameId === game.GameId : false"
          :logo="getProviderLogo(game.GameProviderName)"
          :is-hot="game.IsHotGame"
          :is-new="game.IsNewGame"
          :title="game.EnglishGameName"
          :text="providerCount[game.GameProviderName] > 1 ? game.GameName : game.GameNameForDisplay"
          @click="handleSelectGame(game, index)"
          :use-primary-color="isThemeColorUsePrimaryColor"
        />
      </div>
    </div>
    <div class="mb-6 flex justify-center">
      <div class="entry__content-container">
        <h2 class="--text entry-game-name capitalize">{{ activeBtn?.GameName }}</h2>
        <p class="entry__content-text" v-if="!$t(games[currentIndex].IntroForDisplay.short).includes('_')">{{ $t(games[currentIndex].IntroForDisplay.short) }}</p>
        <div
          @click="() => onClickPlayGame(Number(activeBtn?.GameId), isAuthenticated, String(activeBtn?.TabType), EnumEntranceLocation.GameLobby)"
          class="entry__btn"
        >
          {{ $t("play_now") }}
        </div>
      </div>
    </div>
  </div>
    <div
      class="entry mb-10"
      :variant="currentPath"
      :style="[`background-image: url('${getBackgroundImage()}');`]"
    >
      <template v-if="games.length > 0">
        <div class="entry__left">
          <img
            ref="leftImage"
            class="entry__image fadeIn"
            :src="activeBtn ? getLeftImage(activeBtn) : ''"
            @load="handleLoad"
            @error="handleError"
          />
        </div>
      </template>
      <no-game-message v-else />
    </div>
</template>

<script setup lang="ts">
import _ from "lodash";
import { useRoute } from "vue-router";
import { ref, computed, watch } from "vue";
import EntryButton from "./EntryButton.client.vue";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import textHelper from "@/utils/formatHelpers/textFormatHelper";
import NoGameMessage from "@/components/lobby/no-game-message.client.vue";

const props = defineProps({
  games: {
    type: Array as PropType<Array<GameBsi>>,
    required: true,
  },
  tagLine: {
    type: String,
    required: false,
    default: "",
  },
});
const providerCount = textHelper.checkMultiple(props.games);

const route = useRoute();
const { convertString } = textHelper;
const { getAssetImage, onClickPlayGame } = commonHelper;

const activeBtn = ref<GameBsi | undefined>(_.first(props.games));
const leftImage = ref<Element | undefined>();
const rightLogo = ref<Element | undefined>();
const currentPath = computed(() =>
  route.path.replace("/", "").replaceAll("-", "_").trim().toLowerCase()
);
const isAuthenticated = computed(() => store.state.auth);
const totalLines = computed(() => {
  const totalGames = props.games.length;
  const gamesPerLine = 8;
  const total = totalGames / gamesPerLine;
  if (total <= 1) return 1;
  return Math.ceil(total);
});

const getProviderLogo = (providerName: string): string => {
  try {
    const fileName = `provider_logo_${convertString(providerName, true)}.png`;
    return getAssetImage(
      `assets/theme/bk8/desktop/logos/providers/${fileName}`
    );
  } catch (error) {
    return "";
  }
};
const getLeftImage = (game: GameBsi): string => {
  try {
    let fileName = `banner_${currentPath.value}_${convertString(
      game.GameProviderName,
      true
    )}.png`;
    if (game.GameProviderId === 1052) {
      fileName = `banner_${currentPath.value}_${convertString(
        game.GameProviderName,
        true
      )}new.png`;
    }
    if (currentPath.value === "virtual_sports") {
      fileName = `banner_${currentPath.value}_${convertString(
        game.EnglishGameName,
        true
      )}.png`;
    }
    return getAssetImage(`assets/theme/bk8/desktop/banners/${fileName}`);
  } catch (error) {
    return "";
  }
};
const getBackgroundImage = (): string => {
  try {
    const fileName = `banner_${currentPath.value}_background.png`;
    return getAssetImage(`assets/theme/bk8/desktop/banners/${fileName}`);
  } catch (error) {
    return "";
  }
};
const currentIndex = ref(0);
const handleSelectGame = (game: GameBsi, currIndex: number): void => {
  activeBtn.value = game;
  currentIndex.value = currIndex;
};
const handleError = (e: Event): void => {
  if (!e.currentTarget) return;
  // @ts-ignore
  e.currentTarget.style.display = "none";
};
const handleLoad = (e: Event): void => {
  if (!e.currentTarget) return;
  // @ts-ignore
  e.currentTarget.style.display = "block";
};
/**
 * animates an element by adding and removing fadeIn class after a set duration
 * @param {element} element element to animate
 * @param {number} duration time to remove class in seconds
 */
const animateFadeIn = (
  element: Element | null | undefined,
  duration = 0.4
): void => {
  if (!element) return;
  element.classList.add("fadeIn");
  setTimeout(() => {
    element.classList.remove("fadeIn");
  }, duration * 1000);
};
const handleActiveBtnChange = async (): Promise<void> => {
  if (!activeBtn.value) return;

  if (leftImage.value) {
    animateFadeIn(leftImage.value);
  }
  if (rightLogo.value) {
    animateFadeIn(rightLogo.value);
  }
};

const setedLogo = ref<Array<string>>([]);
const isExistLogo = (logo: string, index: number): boolean => {
  if (index === 0) {
    setedLogo.value = [];
  }
  if (setedLogo.value.includes(logo)) {
    return true;
  }
  setedLogo.value.push(logo);
  return false;
};

watch(() => activeBtn.value, handleActiveBtnChange);
const themeProperties =
store.state.companyThemePropertiesFromApi.ThemeProperties;
const isThemeColorUsePrimaryColor = computed(() => {
  const themeColor = themePropertyHelper.getSingleThemeProperty(
    themeProperties,
    "theme_color"
  ).Text;
  return ['bk8_green'].includes(themeColor);
});
</script>

<style scoped>
@keyframes fadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
.no-game-message {
  color: var(--text5);
}
.entry {
  aspect-ratio: 3.125;
  width: 100%;
  max-height: 460px;
  height: 100%;
  background-repeat: no-repeat;
  background-position: center;
  background-size: 100% 460px;
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
}
.entry__left {
  width: 460px;
  height: 460px;
}
.entry__image {
  height: 100%;
  object-fit: contain;
}
.entry[variant="virtual_sports"] .entry__content-container {
  margin-left: unset;
}
.entry__content-container {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  gap: 10px;
}
.entry__logo-container {
  aspect-ratio: 2.5;
  max-width: 240px;
  width: 100%;
  display: flex;
  align-items: center;
  overflow: hidden;
}
.entry__logo {
  width: 100%;
  height: 100%;
  object-fit: contain;
}
.fadeIn {
  animation: fadeIn 0.4s ease-in-out forwards;
}
.entry__content-text {
  padding: 0 0.25rem;
  text-align: center;
  color: var(--text);
}
.entry__btn {
  aspect-ratio: 4.25;
  min-width: 320px;
  height: 36px;
  background: var(--primary);
  border-radius: 4px;
  color: var(--textBtn);
  font-size: 12px;
  line-height: 14px;
  font-weight: 700;
  display: flex;
  align-items: center;
  justify-content: center;
}
.entry__buttons-container {
  width: 100%;
  height: max-content;
  display: flex;
  background: var(--background1);
  border-radius: 8px;
}
.entry__buttons {
  position: relative;
  max-width: 1200px;
  width: 100%;
  gap: 16px 8px;
  display: flex;
  align-items: center;
  flex-wrap: wrap;
}
.entry__buttons[overflow="true"] {
  justify-content: start;
}
.entry-game-name {
  font-weight: 600;
  font-size: 40px;
  line-height: 47px;
}
</style>
